
#ifndef LEVEL_H
#define LEVEL_H

bool loadLevel(levelStruct *level, char *filename);
bool quickLoadLevel(levelStruct *level, char *filename);
bool loadLevelOld(levelStruct *level, char *filename);
void parseGlobalOption(int option, char *arguments, levelStruct *level, int quickParseMap);
void parseMapOptions(levelStruct *level, long position, mapStruct *map, int full_loading);
int getOptionNumber(char *argument);
void mapOption(int option, char *arg, mapStruct *map);
void levelOption(int option, char *arg, levelStruct *level);
void interpretData(mapStruct *map, levelStruct *level);
void initLevel(levelStruct *level);
unsigned long int checksum(char *);
char *cut(char *arg);


#define match(s) (strcmp(cmd, s) == 0)
	
// Known options and corresponding code
// HEX 0x00 - 0x7F reserved to global options
// HEX 0x80 - 0xFF reserverd to map options

#define NAME 		0x00 		 	// Name of the level
#define DESC 		0x01  		// Description of the level
#define TILESET	0x02 			// Tileset name
#define LIVES   0x03			// Number of lives
#define CARAI   0x04			// 0 - Original mode
													// 1 - Only small changes
													// 2 - No car AI
#define BORDER	0x05			// Border (argument is thickness)
#define SOUND		0x06			// Soundfile and arguments
#define RESOL   0x07      // Resolution of the screen

#define SIZE 		0x80			// Map size
#define SPEED 	0x81			// Car speed
#define FUEL		0x82			// Fuel
#define BONUS 	0x83			// Bonus map
#define FUELPTS	0x84			// How many fuel for a extra point (if positive)
													// How many points for each extra fuel (if negative)
#define RADARMODE 0x85		// 0 - Original radar
													// 1 - Sonar like (thanks to AnatolyA. Orehovsky for the code)
													// 2 - Fuel sonar mode (like sonar, but range is proportional to fuel)
													// 3 - Full map
#define ENEMYWAIT 0x86		// How many turns the enemy will wait before starting

#endif
